## otb 7.0.0+dfsg

=== CMakeLists.txt ===
#
# Copyright (C) 2005-2019 Centre National d'Etudes Spatiales (CNES)
#
# This file is part of Orfeo Toolbox
#
#     https://www.orfeo-toolbox.org/
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

cmake_minimum_required(VERSION 3.10.2)

foreach(p
    CMP0072 # CMake 3.11
    CMP0078 # CMake 3.13
    CMP0086 # CMake 3.14
    )
  if(POLICY ${p})
    cmake_policy(SET ${p} NEW)
  endif()
endforeach()

project(OTB)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Check compiler versions
set(OTB_MIN_GNU_VER 5)
set(OTB_MIN_MSVC_VER 19)
set(OTB_MIN_Clang_VER 3.4)
if(DEFINED OTB_MIN_${CMAKE_CXX_COMPILER_ID}_VER)
  if(CMAKE_CXX_COMPILER_VERSION AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS ${OTB_MIN_${CMAKE_CXX_COMPILER_ID}_VER})
    message(STATUS "WARNING: the version of your ${CMAKE_CXX_COMPILER_ID} "
      "compiler is not supported by Orfeo ToolBox (C++14 support might be "
      "incomplete). Please consider updating your compiler to version "
      "${OTB_MIN_${CMAKE_CXX_COMPILER_ID}_VER} or later.")
  endif()
endif()

include(CMakeDependentOption)
#
# use ExternalProject
include(ExternalProject)

#mantis: 1193
if(APPLE)
  # https://cmake.org/cmake/help/v3.10/variable/CMAKE_SYSTEM_FRAMEWORK_PATH.html
  # By default it contains the standard directories for the current system. It 
  # is not intended to be modified by the project, use CMAKE_FRAMEWORK_PATH 
  # for this.
  set(CMAKE_SYSTEM_FRAMEWORK_PATH "" CACHE PATH "" FORCE)
endif()

if( CMAKE_HOST_WIN32 )

  string( LENGTH "${CMAKE_CURRENT_SOURCE_DIR}" n )
  if( n GREATER 50 )
    message(
      FATAL_ERROR
      "OTB source code directory path length is too long (${n} > 50)."
      "Please move the OTB source code directory to a directory with a shorter path."
      )
  endif()

  string( LENGTH "${CMAKE_CURRENT_BINARY_DIR}" n )
  if( n GREATER 50 )
    message(
      FATAL_ERROR
      "OTB build directory path length is too long (${n} > 50)."
      "Please set the OTB build directory to a directory with a shorter path."
      )
  endif()

endif()
set(OTB_APPLICATIONS_NAME_LIST "" CACHE STRING "List of all applications" FORCE)
mark_as_advanced(OTB_APPLICATIONS_NAME_LIST)

set(OTB_CMAKE_DIR ${OTB_SOURCE_DIR}/CMake)
set(CMAKE_MODULE_PATH ${OTB_CMAKE_DIR} ${CMAKE_MODULE_PATH})
include(SourceStatus)
include(PreventInSourceBuilds)
include(PreventInBuildInstalls)
include(OTBModuleMacros)
include(OTBModuleRemote)
include(OTBModuleTest)
include( i18n_qt )

reset_qt_i18n_sources()

repository_status(${PROJECT_SOURCE_DIR} OTB_GIT_STATUS_MESSAGE)

# Find python stuff
# Version 3 is preferred before 2
set ( Python_ADDITIONAL_VERSIONS "3;2" )
set ( PythonInterp_FIND_REQUIRED ${OTB_WRAP_PYTHON} )
set ( PythonLibs_FIND_REQUIRED ${OTB_WRAP_PYTHON} )
find_package( PythonInterp )
if ( OTB_WRAP_PYTHON AND ( "x${PYTHON_VERSION_MAJOR}" STREQUAL "x2" ) )
    message (WARNING "Python3 not found. There is no longer support of \
    wrapping in python2 in OTB, but it can still be used.")
endif()
# Now that we have a python version the addditional versions should only
# contain the version we have to get the corresponding libs
set (Python_ADDITIONAL_VERSIONS "${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}")
find_package ( PythonLibs )

#-----------------------------------------------------------------------------
# Configure the default OTB_DATA_ROOT for the location of OTB Data.
find_path(OTB_DATA_ROOT
  NAMES README-OTB-Data
  HINTS ${OTB_SOURCE_DIR}/Data
  )
#mark_as_advanced(OTB_DATA_ROOT)

if(OTB_DATA_ROOT)
  repository_status(${OTB_DATA_ROOT} OTB_DATA_GIT_STATUS_MESSAGE)
endif()

set(main_project_name ${_OTBModuleMacros_DEFAULT_LABEL})

#-----------------------------------------------------------------------------
# OTB version number.
set(OTB_VERSION_MAJOR "7")
set(OTB_VERSION_MINOR "0")
set(OTB_VERSION_PATCH "0")
set(OTB_VERSION_STRING "${OTB_VERSION_MAJOR}.${OTB_VERSION_MINOR}.${OTB_VERSION_PATCH}")

# Monteverdi version number (follows OTB)
set( Monteverdi_VERSION_MAJOR ${OTB_VERSION_MAJOR} )
set( Monteverdi_VERSION_MINOR ${OTB_VERSION_MINOR} )
set( Monteverdi_VERSION_PATCH ${OTB_VERSION_PATCH} )
set( Monteverdi_VERSION_SUFFIX "" )

set( Monteverdi_VERSION_STRING
  "${Monteverdi_VERSION_MAJOR}.${Monteverdi_VERSION_MINOR}.${Monteverdi_VERSION_PATCH}${Monteverdi_VERSION_SUFFIX}"
  )

#-----------------------------------------------------------------------------
string(TIMESTAMP OTB_BUILD_TIMESTAMP)

if(NOT OTB_INSTALL_RUNTIME_DIR)
  set(OTB_INSTALL_RUNTIME_DIR bin)
endif()
if(NOT OTB_INSTALL_LIBRARY_DIR)
  set(OTB_INSTALL_LIBRARY_DIR lib)
endif()
if(NOT OTB_INSTALL_ARCHIVE_DIR)
  set(OTB_INSTALL_ARCHIVE_DIR lib)
endif()
if(NOT OTB_INSTALL_INCLUDE_DIR)
  set(OTB_INSTALL_INCLUDE_DIR include/OTB-${OTB_VERSION_MAJOR}.${OTB_VERSION_MINOR})
endif()
if(NOT OTB_INSTALL_APP_DIR)
  set(OTB_INSTALL_APP_DIR "${OTB_INSTALL_LIBRARY_DIR}/otb/applications")
endif()
if(NOT OTB_INSTALL_PYTHON_DIR)
  set(OTB_INSTALL_PYTHON_DIR "${OTB_INSTALL_LIBRARY_DIR}/otb/python")
endif()
if(NOT OTB_INSTALL_DATA_DIR)
  set(OTB_INSTALL_DATA_DIR "share/otb")
endif()

if(NOT OTB_INSTALL_DOC_DIR)
  set(OTB_INSTALL_DOC_DIR "share/doc/otb")
endif()
if(NOT OTB_INSTALL_PACKAGE_DIR)
  set(OTB_INSTALL_PACKAGE_DIR "${OTB_INSTALL_LIBRARY_DIR}/cmake/OTB-${OTB_VERSION_MAJOR}.${OTB_VERSION_MINOR}")
endif()

#convert path to native for reconfiguring otbcli.bat.in
file(TO_NATIVE_PATH "${OTB_INSTALL_APP_DIR}" OTB_INSTALL_APP_DIR_NATIVE)

#-----------------------------------------------------------------------------
# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()


#-----------------------------------------------------------------------------
# Enable running cppcheck for each module on its source and test directories.
option(OTB_CPPCHECK_TEST "Run cppcheck for static code analysis" OFF)
mark_as_advanced(OTB_CPPCHECK_TEST)

#-----------------------------------------------------------------------------
# Forbid downloading resources from the network during a build. This helps
# when building on systems without network connectivity to determine which
# resources much be obtained manually and made available to the build.
option(OTB_FORBID_DOWNLOADS "Do not download source code or data from the network" OFF)
mark_as_advanced(OTB_FORBID_DOWNLOADS)
macro(otb_download_attempt_check _name)
  if(OTB_FORBID_DOWNLOADS)
    message(SEND_ERROR "Attempted to download ${_name} when OTB_FORBID_DOWNLOADS is ON")
  endif()
endmacro()

# TODO : handle shared libs on windows
option(BUILD_SHARED_LIBS "Build OTB with shared libraries." ON)
mark_as_advanced(BUILD_SHARED_LIBS)

# The following variable can be deleted and replace by BUILD_SHARED_LIBS
# in otbConfigure.h.in
set(OTB_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})


if(MSVC)
  option(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS "Build OTB with shared libraries." ON)
  mark_as_advanced(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS)
  set(OTB_CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ${CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS})
else()
  set(OTB_CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS OFF)
endif()

# Although the OpenMP option looks like a 3rd party module, it is NOT. This option
# is handled with other compilation flags in file OTBSetStandardCompilerFlags.cmake
# before any module is parsed or enabled (see OTBModuleEnablement.cmake later on
# during configure). Trying to modify this option from any module is
# useless. Any 3rd party module dragging OpenMP should append
# the corresponding flags to CMAKE_CXX_FLAGS, CMAKE_EXE_LINKER_FLAGS, and so on.
option(OTB_USE_OPENMP "Add openmp compiler and linker flags" OFF)

option(OTB_USE_SSE_FLAGS "Enable SIMD optimizations (hardware dependent)." ON)
mark_as_advanced(OTB_USE_SSE_FLAGS)

include(OTBSetStandardCompilerFlags)
#---------------------------------------------------------------
# run try compiles and tests for OTB

# TODO check if we need this
#include(otbTestFriendTemplatedFunction)

set(CMAKE_C_FLAGS "${OTB_REQUIRED_C_FLAGS} ${CMAKE_C_FLAGS}")
set(CMAKE_CXX_FLAGS "${OTB_REQUIRED_CXX_FLAGS} ${CMAKE_CXX_FLAGS}")
set(CMAKE_EXE_LINKER_FLAGS "${OTB_REQUIRED_LINK_FLAGS} ${CMAKE_EXE_LINKER_FLAGS}")
set(CMAKE_SHARED_LINKER_FLAGS "${OTB_REQUIRED_LINK_FLAGS} ${CMAKE_SHARED_LINKER_FLAGS}")
set(CMAKE_MODULE_LINKER_FLAGS "${OTB_REQUIRED_LINK_FLAGS} ${CMAKE_MODULE_LINKER_FLAGS}")

# TODO BUILD_TESTING is created by default by CTest.cmake, and is ON by default.
option(BUILD_TESTING "Build the testing tree." OFF)

include(CTest)

include( CppcheckTargets )

# Setup build locations.
if(NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${OTB_BINARY_DIR}/bin)
endif()
if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${OTB_BINARY_DIR}/lib)
endif()
if(NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${OTB_BINARY_DIR}/lib)
endif()
set(OTB_MODULES_DIR "${OTB_BINARY_DIR}/${OTB_INSTALL_PACKAGE_DIR}/Modules")

#-----------------------------------------------------------------------------
# By default, OTB does not build the Examples that are illustrated in the Software Guide
option(BUILD_EXAMPLES "Build the Examples directory." OFF)

#----------------------------------------------------------------------------
set(OTB_TEST_OUTPUT_DIR "${OTB_BINARY_DIR}/Testing/Temporary")

option(OTB_DATA_USE_LARGEINPUT "Use Large inputs images test." OFF)
mark_as_advanced(OTB_DATA_USE_LARGEINPUT)
if(OTB_DATA_USE_LARGEINPUT)
  find_path(OTB_DATA_LARGEINPUT_ROOT
    NAMES OTBData.readme
    HINTS $ENV{OTB_DATA_LARGEINPUT_ROOT}
  )
  mark_as_advanced(OTB_DATA_LARGEINPUT_ROOT)
endif()

# Small macro to copy a file and rename it
macro(otb_copy_rename _input _output)
  execute_process(
    COMMAND ${CMAKE_COMMAND} -E copy_if_different "${_input}" "${_output}"
    RESULT_VARIABLE _err_code
    OUTPUT_QUIET
    ERROR_QUIET
    )
  if(_err_code)
    message(FATAL_ERROR "Failed to copy file ${_input} to ${_output}")
  endif()
endmacro()

#Generate cmake variables with a set of largeinput data used in tests
include(OTBManageLargeInputPaths)

set(BASELINE       ${OTB_DATA_ROOT}/Baseline/OTB/Images)
set(BASELINE_FILES ${OTB_DATA_ROOT}/Baseline/OTB/Files)
set(INPUTDATA      ${OTB_DATA_ROOT}/Input)
set(TEMP           ${OTB_BINARY_DIR}/Testing/Temporary)
set(OTBAPP_BASELINE       ${OTB_DATA_ROOT}/Baseline/OTB-Applications/Images)
set(OTBAPP_BASELINE_FILES ${OTB_DATA_ROOT}/Baseline/OTB-Applications/Files)

set(NOTOL      0.0)
set(EPSILON_1  0.1)
set(EPSILON_2  0.01)
set(EPSILON_3  0.001)
set(EPSILON_4  0.0001)
set(EPSILON_5  0.00001)
set(EPSILON_6  0.000001)
set(EPSILON_7  0.0000001)
set(EPSILON_8  0.00000001)
set(EPSILON_9  0.000000001)
set(EPSILON_10 0.0000000001)
set(EPSILON_11 0.00000000001)
set(EPSILON_12 0.000000000001)
set(EPSILON_13 0.0000000000001)
set(EPSILON_14 0.00000000000001)
set(EPSILON_15 0.000000000000001)

# Location of OTB Example Data.
set(OTB_EXAMPLE_DATA_ROOT "${OTB_SOURCE_DIR}/Examples/Data")

#----------------------------------------------------------------------
# Make sure remote modules are downloaded before sorting out the module
# dependencies.
add_subdirectory(Modules/Remote)

=== Application/CMakeLists.txt ===
#
# Copyright (C) 2005-2019 Centre National d'Etudes Spatiales (CNES)
#
# This file is part of Orfeo Toolbox
#
#     https://www.orfeo-toolbox.org/
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

project(ApplicationExamples)

otb_create_application(
  NAME           ApplicationExample
  SOURCES        ApplicationExample.cxx
  LINK_LIBRARIES ${OTB_LIBRARIES})

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== BasicFilters/CMakeLists.txt ===
#
# Copyright (C) 2005-2019 Centre National d'Etudes Spatiales (CNES)
#
# This file is part of Orfeo Toolbox
#
#     https://www.orfeo-toolbox.org/
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

project(BasicFiltersExamples)

#OTB_USE_MUPARSER is OFF
if(OTBMathParser_LOADED)
add_executable(BandMathFilterExample BandMathFilterExample.cxx)
target_link_libraries(BandMathFilterExample ${OTB_LIBRARIES})
endif()

#OTB_USE_MUPARSERX is OFF
if(OTBMathParserX_LOADED)
add_executable(BandMathXImageFilterExample BandMathXImageFilterExample.cxx)
target_link_libraries(BandMathXImageFilterExample ${OTB_LIBRARIES})
endif()

add_executable(DEMToRainbowExample DEMToRainbowExample.cxx)
target_link_libraries(DEMToRainbowExample ${OTB_LIBRARIES})

add_executable(FrostImageFilter FrostImageFilter.cxx)
target_link_libraries(FrostImageFilter ${OTB_LIBRARIES})

add_executable(HillShadingExample HillShadingExample.cxx)
target_link_libraries(HillShadingExample ${OTB_LIBRARIES})

add_executable(IndexedToRGBExample IndexedToRGBExample.cxx)
target_link_libraries(IndexedToRGBExample ${OTB_LIBRARIES})

add_executable(LeeImageFilter LeeImageFilter.cxx)
target_link_libraries(LeeImageFilter ${OTB_LIBRARIES})

#OTBMeanShift depends OTBMathParser. But OTB_USE_MUPARSER is OFF
if(OTBMathParser_LOADED)
add_executable(MeanShiftSegmentationFilterExample MeanShiftSegmentationFilterExample.cxx)
target_link_libraries(MeanShiftSegmentationFilterExample ${OTB_LIBRARIES})
endif()

add_executable(PrintableImageFilterExample PrintableImageFilterExample.cxx)
target_link_libraries(PrintableImageFilterExample ${OTB_LIBRARIES})

add_executable(ScalingFilterExample ScalingFilterExample.cxx)
target_link_libraries(ScalingFilterExample ${OTB_LIBRARIES})


if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== ChangeDetection/CMakeLists.txt ===
#
# Copyright (C) 2005-2019 Centre National d'Etudes Spatiales (CNES)
#
# This file is part of Orfeo Toolbox
#
#     https://www.orfeo-toolbox.org/
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

project(ChangeDetectionExamples)

add_executable(CorrelChDet CorrelChDet.cxx)
target_link_libraries(CorrelChDet ${OTB_LIBRARIES})

add_executable(DiffChDet DiffChDet.cxx)
target_link_libraries(DiffChDet ${OTB_LIBRARIES})

add_executable(KullbackLeiblerDistanceChDet KullbackLeiblerDistanceChDet.cxx)
target_link_libraries(KullbackLeiblerDistanceChDet ${OTB_LIBRARIES})

add_executable(KullbackLeiblerProfileChDet KullbackLeiblerProfileChDet.cxx)
target_link_libraries(KullbackLeiblerProfileChDet ${OTB_LIBRARIES})

add_executable(MultivariateAlterationDetector MultivariateAlterationDetector.cxx)
target_link_libraries(MultivariateAlterationDetector ${OTB_LIBRARIES})

add_executable(RatioChDet RatioChDet.cxx)
target_link_libraries(RatioChDet ${OTB_LIBRARIES})


if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== Classification/CMakeLists.txt ===
#
# Copyright (C) 2005-2019 Centre National d'Etudes Spatiales (CNES)
#
# This file is part of Orfeo Toolbox
#
#     https://www.orfeo-toolbox.org/
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

project(ClassificationExamples)


add_executable(ClassificationMapRegularizationExample ClassificationMapRegularizationExample.cxx)
target_link_libraries(ClassificationMapRegularizationExample ${OTB_LIBRARIES})

#OTBDempsterShafer depends OTBMathParser. But OTB_USE_MUPARSER is OFF
if(OTBMathParser_LOADED)
add_executable(DempsterShaferFusionOfClassificationMapsExample DempsterShaferFusionOfClassificationMapsExample.cxx)
target_link_libraries(DempsterShaferFusionOfClassificationMapsExample ${OTB_LIBRARIES})
endif()

add_executable(SOMImageClassificationExample SOMImageClassificationExample.cxx)
target_link_libraries(SOMImageClassificationExample ${OTB_LIBRARIES})

add_executable(SupervisedImageClassificationExample SupervisedImageClassificationExample.cxx)
target_link_libraries(SupervisedImageClassificationExample ${OTB_LIBRARIES})


if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== Completion/CMakeLists.txt ===
#
# Copyright (C) 2005-2019 Centre National d'Etudes Spatiales (CNES)
#
# This file is part of Orfeo Toolbox
#
#     https://www.orfeo-toolbox.org/
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

find_package(OTB REQUIRED)
include(${OTB_USE_FILE})

add_executable(completionGenerator EXCLUDE_FROM_ALL completionGenerator.cxx)
target_link_libraries(completionGenerator ${OTB_LIBRARIES})

add_custom_target(generate-completion
    COMMAND bin/completionGenerator lib/otb/applications otbcli_completion
    DEPENDS completionGenerator
    WORKING_DIRECTORY ${OTB_BINARY_DIR}
    )

=== DimensionReduction/CMakeLists.txt ===
#
# Copyright (C) 2005-2019 Centre National d'Etudes Spatiales (CNES)
#
# This file is part of Orfeo Toolbox
#
#     https://www.orfeo-toolbox.org/
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

project(DimensionReductionExamples)

add_executable(ICAExample ICAExample.cxx)
target_link_libraries(ICAExample ${OTB_LIBRARIES})

add_executable(MaximumAutocorrelationFactor MaximumAutocorrelationFactor.cxx)
target_link_libraries(MaximumAutocorrelationFactor ${OTB_LIBRARIES})

add_executable(MNFExample MNFExample.cxx)
target_link_libraries(MNFExample ${OTB_LIBRARIES})

add_executable(NAPCAExample NAPCAExample.cxx)
target_link_libraries(NAPCAExample ${OTB_LIBRARIES})

add_executable(PCAExample PCAExample.cxx)
target_link_libraries(PCAExample ${OTB_LIBRARIES})

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== DisparityMap/CMakeLists.txt ===
#
# Copyright (C) 2005-2019 Centre National d'Etudes Spatiales (CNES)
#
# This file is part of Orfeo Toolbox
#
#     https://www.orfeo-toolbox.org/
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

project(DisparityMapExamples)

add_executable(FineRegistrationImageFilterExample FineRegistrationImageFilterExample.cxx)
target_link_libraries(FineRegistrationImageFilterExample ${OTB_LIBRARIES})

add_executable(NCCRegistrationFilterExample NCCRegistrationFilterExample.cxx)
target_link_libraries(NCCRegistrationFilterExample ${OTB_LIBRARIES})

#StereoReconstructionExample depends OTBMathParser. But OTB_USE_MUPARSER is OFF
if(OTBMathParser_LOADED)
add_executable(StereoReconstructionExample StereoReconstructionExample.cxx)
target_link_libraries(StereoReconstructionExample ${OTB_LIBRARIES})
endif()

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== FeatureExtraction/CMakeLists.txt ===
#
# Copyright (C) 2005-2019 Centre National d'Etudes Spatiales (CNES)
#
# This file is part of Orfeo Toolbox
#
#     https://www.orfeo-toolbox.org/
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

project(FeatureExtractionExamples)

add_executable(AsymmetricFusionOfLineDetectorExample AsymmetricFusionOfLineDetectorExample.cxx)
target_link_libraries(AsymmetricFusionOfLineDetectorExample ${OTB_LIBRARIES})

add_executable(CloudDetectionExample CloudDetectionExample.cxx)
target_link_libraries(CloudDetectionExample ${OTB_LIBRARIES})

add_executable(ComplexMomentPathExample ComplexMomentPathExample.cxx)
target_link_libraries(ComplexMomentPathExample ${OTB_LIBRARIES})

add_executable(ComplexMomentsImageFunctionExample ComplexMomentsImageFunctionExample.cxx)
target_link_libraries(ComplexMomentsImageFunctionExample ${OTB_LIBRARIES})

add_executable(CorrelationLineDetectorExample CorrelationLineDetectorExample.cxx)
target_link_libraries(CorrelationLineDetectorExample ${OTB_LIBRARIES})

add_executable(EdgeDensityExample EdgeDensityExample.cxx)
target_link_libraries(EdgeDensityExample ${OTB_LIBRARIES})

add_executable(FlusserMomentsImageFunctionExample FlusserMomentsImageFunctionExample.cxx)
target_link_libraries(FlusserMomentsImageFunctionExample ${OTB_LIBRARIES})

add_executable(HarrisExample HarrisExample.cxx)
target_link_libraries(HarrisExample ${OTB_LIBRARIES})

add_executable(HuMomentsImageFunctionExample HuMomentsImageFunctionExample.cxx)
target_link_libraries(HuMomentsImageFunctionExample ${OTB_LIBRARIES})

add_executable(LineSegmentDetectorExample LineSegmentDetectorExample.cxx)
target_link_libraries(LineSegmentDetectorExample ${OTB_LIBRARIES})

add_executable(RightAngleDetectionExample RightAngleDetectionExample.cxx)
target_link_libraries(RightAngleDetectionExample ${OTB_LIBRARIES})

add_executable(PanTexExample PanTexExample.cxx)
target_link_libraries(PanTexExample ${OTB_LIBRARIES})

add_executable(RatioLineDetectorExample RatioLineDetectorExample.cxx)
target_link_libraries(RatioLineDetectorExample ${OTB_LIBRARIES})

add_executable(SFSExample SFSExample.cxx)
target_link_libraries(SFSExample ${OTB_LIBRARIES})

add_executable(SURFExample SURFExample.cxx)
target_link_libraries(SURFExample ${OTB_LIBRARIES})

add_executable(TextureExample TextureExample.cxx)
target_link_libraries(TextureExample ${OTB_LIBRARIES})

add_executable(ThresholdToPointSetExample ThresholdToPointSetExample.cxx)
target_link_libraries(ThresholdToPointSetExample ${OTB_LIBRARIES})

add_executable(TouziEdgeDetectorExample TouziEdgeDetectorExample.cxx)
target_link_libraries(TouziEdgeDetectorExample ${OTB_LIBRARIES})


if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== Filtering/CMakeLists.txt ===
#
# Copyright (C) 2005-2019 Centre National d'Etudes Spatiales (CNES)
#
# This file is part of Orfeo Toolbox
#
#     https://www.orfeo-toolbox.org/
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

project(FilteringExamples)

add_executable(CompositeFilterExample CompositeFilterExample.cxx)
target_link_libraries(CompositeFilterExample ${OTB_LIBRARIES})

add_executable(DanielssonDistanceMapImageFilter DanielssonDistanceMapImageFilter.cxx)
target_link_libraries(DanielssonDistanceMapImageFilter ${OTB_LIBRARIES})

add_executable(SecondDerivativeRecursiveGaussianImageFilter SecondDerivativeRecursiveGaussianImageFilter.cxx)
target_link_libraries(SecondDerivativeRecursiveGaussianImageFilter ${OTB_LIBRARIES})

if (Module_OTBVectorDataRendering)
  add_executable(RasterizationExample RasterizationExample.cxx)
  target_link_libraries(RasterizationExample ${OTB_LIBRARIES})
endif()

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== Fusion/CMakeLists.txt ===
#
# Copyright (C) 2005-2019 Centre National d'Etudes Spatiales (CNES)
#
# This file is part of Orfeo Toolbox
#
#     https://www.orfeo-toolbox.org/
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

project(FusionExamples)

add_executable(BayesianFusionImageFilter BayesianFusionImageFilter.cxx)
target_link_libraries(BayesianFusionImageFilter ${OTB_LIBRARIES})

add_executable(PanSharpeningExample PanSharpeningExample.cxx)
target_link_libraries(PanSharpeningExample ${OTB_LIBRARIES})


if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== Hyperspectral/CMakeLists.txt ===
#
# Copyright (C) 2005-2019 Centre National d'Etudes Spatiales (CNES)
#
# This file is part of Orfeo Toolbox
#
#     https://www.orfeo-toolbox.org/
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

project(HyperspectralExamples)

add_executable(HyperspectralUnmixingExample HyperspectralUnmixingExample.cxx)
target_link_libraries(HyperspectralUnmixingExample ${OTB_LIBRARIES})


if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== debian/changelog ===
otb (7.0.0+dfsg-2build3) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:22:12 +0100

otb (7.0.0+dfsg-2build2) focal; urgency=medium

  * No-change upload for opencv soname changes.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 02 Feb 2020 09:17:09 +0100

otb (7.0.0+dfsg-2build1) focal; urgency=medium

  * No-change rebuild for gdal soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 14 Jan 2020 14:33:02 +0000

otb (7.0.0+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Drop Name field from upstream metadata.
  * Replace libqt4-sql-sqlite with libqt5sql5-sqlite.
    (closes: #947226)
  * Update symbols for amd64 & i386.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 23 Dec 2019 09:46:16 +0100

otb (7.0.0+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update symbols for 7.0.0~rc2.
  * Strip pre-release from symbols version.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 29 Oct 2019 16:33:24 +0100

otb (7.0.0~rc2+dfsg-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release candidate.
  * Bump Standards-Version to 4.4.1, no changes.
  * Drop spelling-errors.patch, applied upstream.
  * Update symbols for amd64.
  * Drop unused override for spelling-error-in-binary.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 24 Oct 2019 12:55:02 +0200

otb (7.0.0~rc1+dfsg-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release candidate.
  * Use ${python3:Depends} substvar for python3-otb.
  * Update symbols for amd64 & i386.
  * Drop patches, applied/fixed upstream.
  * Update copyright years for CNES.
  * Drop library packages no longer built.
  * Drop python package, no longer built.
  * Drop unused OTB_USE_MAPNIK option.
  * Drop unused overrides for file-references-package-build-path.
  * Add lintian overrides for binary-without-manpage.
  * Add patch to fix spelling errors.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 27 Sep 2019 11:40:44 +0200

otb (6.6.1+dfsg-3) unstable; urgency=medium

  * Add patch to fix FTBFS with OSSIM 2.9.1.
  * Add patch to support GDAL 3.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 10 Sep 2019 21:37:47 +0200

=== debian/control ===
Source: otb
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Paolo Cavallini <cavallini@faunalia.it>,
           Rashad Kanavath <rashad.kanavath@c-s.fr>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               dh-exec,
               dpkg-dev (>= 1.16.1~),
               cmake (>= 3.1.0),
               libboost-date-time-dev,
               libboost-filesystem-dev,
               libboost-graph-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libcurl4-gnutls-dev | libcurl-ssl-dev,
               libexpat1-dev,
               libfftw3-dev,
               libgdal-dev (>= 1.10.0),
               libgeotiff-dev,
               libgl1-mesa-dev | libgl-dev,
               libglew-dev,
               libglfw3-dev,
               libinsighttoolkit4-dev,
               libkml-dev,
               libmuparser-dev,
               libmuparserx-dev,
               libopencv-dev,
               libopenthreads-dev,
               libossim-dev,
               libpng-dev,
               libqt5opengl5-dev,
               libqwt-qt5-dev,
               libsvm-dev,
               libtinyxml-dev,
               libtool,
               pkg-kde-tools,
               qtbase5-dev,
               qttools5-dev,
               swig
Standards-Version: 4.4.1
Vcs-Browser: https://salsa.debian.org/debian-gis-team/otb
Vcs-Git: https://salsa.debian.org/debian-gis-team/otb.git
Homepage: http://www.orfeo-toolbox.org/

Package: libotb-dev
Architecture: any
Section: libdevel
Depends: cmake (>= 2.8.3),
         libboost-date-time-dev,
         libboost-filesystem-dev,
         libboost-graph-dev,
         libboost-program-options-dev,
         libboost-system-dev,
         libboost-thread-dev,
         libgdal-dev (>= 1.10.0),
         libgeotiff-dev,
         libgl1-mesa-dev | libgl-dev,
         libglew-dev,
         libglfw3-dev,
         libinsighttoolkit4-dev,
         libkml-dev,
         libmuparser-dev,
         libmuparserx-dev,
         libopencv-dev,
         libopenthreads-dev,
         libossim-dev,
         libotbapplicationengine-7.0-1 (= ${binary:Version}),
         libotbcarto-7.0-1 (= ${binary:Version}),
         libotbcommandline-7.0-1 (= ${binary:Version}),
         libotbcommon-7.0-1 (= ${binary:Version}),
         libotbcurladapters-7.0-1 (= ${binary:Version}),
         libotbextendedfilename-7.0-1 (= ${binary:Version}),
         libotbfuzzy-7.0-1 (= ${binary:Version}),
         libotbgdaladapters-7.0-1 (= ${binary:Version}),
         libotbice-7.0-1 (= ${binary:Version}),
         libotbimagebase-7.0-1 (= ${binary:Version}),
         libotbimageio-7.0-1 (= ${binary:Version}),
         libotbimagemanipulation-7.0-1 (= ${binary:Version}),
         libotbiobsq-7.0-1 (= ${binary:Version}),
         libotbiogdal-7.0-1 (= ${binary:Version}),
         libotbiokml-7.0-1 (= ${binary:Version}),
         libotbiolum-7.0-1 (= ${binary:Version}),
         libotbiomstar-7.0-1 (= ${binary:Version}),
         libotbioonera-7.0-1 (= ${binary:Version}),
         libotbiorad-7.0-1 (= ${binary:Version}),
         libotblearningbase-7.0-1 (= ${binary:Version}),
         libotbmapla-7.0-1 (= ${binary:Version}),
         libotbmathparser-7.0-1 (= ${binary:Version}),
         libotbmathparserx-7.0-1 (= ${binary:Version}),
         libotbmetadata-7.0-1 (= ${binary:Version}),
         libotbmonteverdi-7.0-1 (= ${binary:Version}),
         libotbmonteverdicore-7.0-1 (= ${binary:Version}),
         libotbmonteverdigui-7.0-1 (= ${binary:Version}),
         libotbossimadapters-7.0-1 (= ${binary:Version}),
         libotbossimplugins-7.0-1 (= ${binary:Version}),
         libotbpolarimetry-7.0-1 (= ${binary:Version}),
         libotbprojection-7.0-1 (= ${binary:Version}),
         libotbqtadapters-7.0-1 (= ${binary:Version}),
         libotbqtwidget-7.0-1 (= ${binary:Version}),
         libotbsampling-7.0-1 (= ${binary:Version}),
         libotbsiftfast-7.0-1 (= ${binary:Version}),
         libotbstatistics-7.0-1 (= ${binary:Version}),
         libotbstreaming-7.0-1 (= ${binary:Version}),
         libotbsupervised-7.0-1 (= ${binary:Version}),
         libotbtestkernel-7.0-1 (= ${binary:Version}),
         libotbvectordatabase-7.0-1 (= ${binary:Version}),
         libotbvectordataio-7.0-1 (= ${binary:Version}),
         libotbwavelet-7.0-1 (= ${binary:Version}),
         libqwt-qt5-dev,
         libsvm-dev,
         monteverdi (= ${binary:Version}),
         otb-testdriver (= ${binary:Version}),
         ${misc:Depends}
Conflicts: libotb3-dev,
           libotb4-dev
Description: Free library of image processing algorithms - development
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the development files needed to build your own OTB
 applications and modules.

Package: otb-qgis
Architecture: any
Section: misc
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ORFEO Toolbox library - otbQgisDescriptor
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the otbQgisDescriptor application.

Package: otb-testdriver
Architecture: any
Section: misc
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ORFEO Toolbox library - OTBTestDriver
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBTestDriver application.

Package: libotbice-7.0-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBIce
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBIce shared library.

Package: libotbiolum-7.0-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBIOLUM
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBIOLUM shared library.

Package: libotbiomstar-7.0-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBIOMSTAR
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBIOMSTAR shared library.

Package: libotbioonera-7.0-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBIOONERA
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBIOONERA shared library.

Package: libotbiorad-7.0-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBIORAD
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBIORAD shared library.

Package: libotbiogdal-7.0-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBIOGDAL
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBIOGDAL shared library.

Package: libotbiobsq-7.0-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBIOBSQ
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBIOBSQ shared library.

Package: libotbiokml-7.0-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBIOKML
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBIOKML shared library.

Package: libotbcurladapters-7.0-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBCurlAdapters
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBCurlAdapters shared library.

Package: libotbossimadapters-7.0-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBOssimAdapters
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBOssimAdapters shared library.

Package: libotbsampling-7.0-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBSampling
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library

=== debian/rules ===
#!/usr/bin/make -f
#
# Copyright (C) 2010-2014 CNES - Centre National d'Etudes Spatiales
# Author: Sebastien DINOT <sebastien.dinot@c-s.fr>
#

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

export DEB_LDFLAGS_MAINT_APPEND = "-Wl,--as-needed"

include /usr/share/dpkg/pkg-info.mk

DEB_BUILD_ARCH     ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

ifndef PKGVERSION
    PKGVERSION=1
endif

TEMPLATES=$(wildcard debian/*lintian-overrides.in)

OTB_VERSION_MAJOR  = $(shell sed -ne 's/set(OTB_VERSION_MAJOR "\([0-9]*\)")/\1/p' CMakeLists.txt)
OTB_VERSION_MINOR  = $(shell sed -ne 's/set(OTB_VERSION_MINOR "\([0-9]*\)")/\1/p' CMakeLists.txt)
OTB_VERSION_PATCH  = $(shell sed -ne 's/set(OTB_VERSION_PATCH "\([0-9]*\)")/\1/p' CMakeLists.txt)
OTB_VERSION_SONAME = $(OTB_VERSION_MAJOR).$(OTB_VERSION_MINOR)
OTB_VERSION_FULL   = $(OTB_VERSION_MAJOR).$(OTB_VERSION_MINOR).$(OTB_VERSION_PATCH)

UPSTREAM_VERSION = $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')

OTB_USE_SSE_FLAGS=ON
ifneq (,$(filter $(DEB_BUILD_ARCH),i386))
	OTB_USE_SSE_FLAGS=OFF
endif

CMAKE_FLAGS = \
	-DBUILD_EXAMPLES:BOOL=OFF \
	-DBUILD_SHARED_LIBS:BOOL=ON \
	-DBUILD_TESTING:BOOL=OFF \
	-DCMAKE_BUILD_TYPE:STRING=Release \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_SKIP_RPATH:BOOL=ON \
	-DOTB_INSTALL_ARCHIVE_DIR:STRING=lib/$(DEB_HOST_MULTIARCH) \
	-DOTB_INSTALL_LIBRARY_DIR:STRING=lib/$(DEB_HOST_MULTIARCH) \
	-DOTB_USE_6S:BOOL=OFF \
	-DOTB_USE_CURL:BOOL=ON \
	-DOTB_USE_GLEW:BOOL=ON \
	-DOTB_USE_GLFW:BOOL=ON \
	-DOTB_USE_LIBKML:BOOL=ON \
	-DOTB_USE_LIBSVM:BOOL=ON \
	-DOTB_USE_MUPARSER:BOOL=ON \
	-DOTB_USE_MUPARSERX:BOOL=ON \
	-DOTB_USE_OPENCV:BOOL=ON \
	-DOTB_USE_OPENGL:BOOL=ON \
	-DOTB_USE_QT:BOOL=ON \
	-DOTB_USE_QWT:BOOL=ON \
	-DOTB_USE_SSE_FLAGS:BOOL=$(OTB_USE_SSE_FLAGS)


DEBPKGNAME     := $(DEB_SOURCE)
pkgcli:=$(DEBPKGNAME)-bin
pkggui:=$(DEBPKGNAME)-bin-qt
pkglib:=lib$(DEBPKGNAME)
pkgdev:=$(pkglib)-dev

templates:

	for TEMPLATE in $(TEMPLATES) ; do \
		sed -e 's/@SOVERSION@/$(OTB_VERSION_SONAME)-1/g' $$TEMPLATE > `echo $$TEMPLATE | sed 's/.lintian-overrides.in$$/-$(OTB_VERSION_SONAME)-1.lintian-overrides/'` ; \
	done
	sed -e 's/@SOVERSION@/$(OTB_VERSION_SONAME)-1/g' debian/control.in > debian/control
	sed -e 's/@SOVERSION@/$(OTB_VERSION_SONAME)/g' debian/libotb-dev.install.in > debian/libotb-dev.install

# rather use all libs since the installed libs are spread over several packages
OTB_LIB_DIRS = $(CURDIR)/debian/tmp/usr/lib

%:
	dh $@ --with pkgkde_symbolshelper --parallel

override_dh_auto_configure: templates
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_makeshlibs:
	dh_makeshlibs -- -c0 -v$(UPSTREAM_VERSION)

override_dh_shlibdeps:
	dh_shlibdeps -l$(OTB_LIB_DIRS)

override_dh_install:
	rm -f $(CURDIR)/debian/tmp/usr/share/doc/otb/LICENSE
	rm -f $(CURDIR)/debian/tmp/usr/share/doc/otb/VERSION
	dh_install --list-missing
	rm -f $(CURDIR)/debian/$(pkglib)/usr/lib/$(DEB_HOST_MULTIARCH)/libOTBWrapper*
	rm -f $(CURDIR)/debian/$(pkgdev)/usr/lib/$(DEB_HOST_MULTIARCH)/libOTBWrapper*

override_dh_installchangelogs:
	dh_installchangelogs RELEASE_NOTES.txt

override_dh_installdocs:
	dh_installdocs -A NOTICE

.PHONY: templates
